#include "stc.h"
#include "i2s.h"

BOOL WaveUpdate;                        //ݸ±־λ
BOOL WavePlayEn;                        //ʹ
BOOL WaveOverrun;                       //־λ
BOOL WaveUnderrun;                      //־λ
BYTE WaveMute;                          //ƼĴ
BYTE WaveWritePtr;                      //лдָ
BYTE WaveReadPtr;                       //лָ
BYTE data WaveDumpSize;                 //
BYTE xdata WaveBuffer[BUFFER_SIZE][BLOCKSIZE];     //ݻ

#define	MCKOE		1		            //I2Sʱ, 0:ֹI2Sʱ, 1:I2Sʱ

#define	I2SEN		0x04	            //I2Sģʹ, 0x00:ֹ, 0x04:
#define	I2S_MODE	2		            //I2Sģʽ, 0:ӻģʽ, 1:ӻģʽ, 2:ģʽ, 3:ģʽ,

#define	PCMSYNC		0		            //PCM֡ͬ, 0: ֡ͬ, 1: ֡ͬ
#define	STD_MODE	0		            //I2S׼ѡ, 0: I2Sֱ׼, 1: MSB׼, 2:LSBҶ׼, 3:PCM׼,  CS3434CS4344Ϊ0:I2Sֱ׼PT8211Ϊ1:MSB׼
#define	CKPOL		0		            //I2S̬ʱӼ, 0:ʱȶ״̬Ϊ͵ƽ, 1:ʱȶ״̬Ϊߵƽ
#define	DATLEN		0		            //ݳ, 0:16λ, 1:24λ, 2:32λ, 3:
#define	CHLEN		0		            //ͨ(ÿƵͨλ), 0:16λ, 1: 32λ

#if (MCKOE == 0)			            //ֹʱ
    #define I2SDIV      (FOSC/(16*2*SAMPFREQ))      //˫ֹʱ 16bit,  2*DIV + ODD = I2Sʱ / 32fs, Ҫ DIV >= 2, Ƶϵ >=4.
#endif
#if (MCKOE == 1)			            //ʱ
    #define I2SDIV      (FOSC/(16*2*8*SAMPFREQ))    //˫ʱ 16bit 256fs,  2*DIV + ODD = I2Sʱ / 256fs, Ҫ DIV >= 2, Ƶϵ >=4.
#endif

void i2s_init()
{
    I2SMD = 0xff;					    //ڲֽ,ΪFFH
    I2SCR = 0x02+0x00;				    //ʹܷͻж(0x80), ʹDMAж(0x02), +0x00:Motorolaʽ, +0x10:TIʽ
    I2SPRH = (MCKOE << 1) + (u8)(I2SDIV & 1);	    //I2Sʱ(I2SMCK), ODD
    I2SPRL = (u8)(I2SDIV/2);		    //I2SʱӷƵ
    I2SCFGH = I2S_MODE;			        //I2SģʽΪģʽ
    I2SCFGL = (PCMSYNC << 7) + (STD_MODE << 4) + (CKPOL << 3) + (DATLEN << 1) + CHLEN;
    P_SW3 = (P_SW3 & 0x3f) | (2<<6);	//I2S˿л, 0: P3.2(BCLK) P3.4(SD) P5.4(MCLK) P3.5(WS),
                                        //             1: P1.5(BCLK) P1.3(SD) P1.6(MCLK) P5.4(WS),
                                        //             2: P2.5(BCLK) P2.3(SD) P5.4(MCLK) P2.2(WS),
                                        //             3: P4.3(BCLK) P4.0(SD) P1.6(MCLK) P5.4(WS),
    I2SCFGH |= I2SEN;                   //ʹI2Sģ
    
    DMA_I2ST_CFG  = 0x80 + (3<<2) + 3;  //0x80:I2ST_DMAжϡ +(3<<2): I2ST_DMAжȼ, 0~33Ϊȼ +3:I2ST_DMAȼ, 3Ϊȼ
    DMA_I2ST_AMTH = (BLOCKSIZE - 1) >> 8;   //I2ST_DMAֽֽ, ʵʴֽ = ֵ+1
    DMA_I2ST_AMT  = (BLOCKSIZE - 1);	    //I2ST_DMAֽֽ
    DMA_I2ST_STA  = 0x00;               //I2ST_DMA״̬Ĵ, bit2:I2SдݸǱ־0bit0:I2ST_DMAж־0
    DMA_I2ST_CR   = 0x80;               //I2ST_DMAƼĴ, 0x80:I2ST_DMA,  0x40:DMA䡣
    
    WavePlayEn = 0;
    WaveMute = 0;
    WaveOverrun = 0;
    WaveUnderrun = 0;
    WaveWritePtr = 0;
    WaveReadPtr = 0;
    WaveDumpSize = 0;
}

void i2s_trig_dma()
{
    DMA_I2ST_TXAH = (WORD)&WaveBuffer[WaveReadPtr] >> 8;    //I2ST_DMAʼַֽ
    DMA_I2ST_TXAL = (WORD)&WaveBuffer[WaveReadPtr];         //I2ST_DMAʼַֽ
    DMA_I2ST_CR   = 0x80 + 0x40;                            //DMA, I2ST_DMAƼĴ, 0x80:I2ST_DMA,  0x40:DMA䡣
    WaveReadPtr++;
    WaveReadPtr &= BUFFER_MASK;
}

void I2stxdma_isr() interrupt 63
{
    if (DMA_I2ST_STA & 0x01)
    {
        DMA_I2ST_STA = 0;   //I2S-DMAжϱ־
        
        WaveDumpSize--;
        if (WaveMute)
        {
            WavePlayEn = 0;             //ʱҪֹͣţԱڽʱԶ
        }
        else
        {
            if (WavePlayEn)
            {
                if (WaveDumpSize)       //жǷ㹻
                {
                    i2s_trig_dma();     //㹻DMAһI2S
                }
                else
                {
                    WaveUnderrun = 1;   //
                    WavePlayEn = 0;
                }
            }
        }
    }
}

